/*
 * sut is generated from model  : {{ model_file }}
 */

package {{ package }};

import java.util.ArrayList;
import java.util.List;

//0.3 import org.apache.log4j.Logger;

public class {{ className }} implements sut.interfaces.SutInterface {
    //0.3 private static final Logger logger = Logger.getLogger({{ className }}.class);

    // Initialize statemachine constants,variables and locations
    {% for name in constants -%}
    final int {{ name  }} = {{ constants[name][1] }};
    {% endfor %}
    {% for name in statevars -%}
    int {{ name  }} = {{ statevars[name][1] }};
    {% endfor %}
    String  guardTaken; 
    Location start,end,middle;

    public enum Location {
        {% for location in locations -%}
        {{ location  }},
        {% endfor -%}
        ERR
    }

    private Location currentLoc = Location.{{initlocation}};


    public void reset() {
        {% for name in statevars -%}
        {{ name  }} = {{ statevars[name][1] }};
        {% endfor -%}
        currentLoc = Location.{{initlocation}};
    }

    public Location getCurrentLocation() {
        return currentLoc;
    }


    //Inputs
    {% for input in inputInterfaces -%}
    public void {{input}}( {% for paramtype in inputInterfaces[input] %} {{paramtype}} tomte_p{{ loop.index0 }} {%- if not loop.last -%}, {%- endif %} {% endfor %} ) {
        switch (currentLoc) {
        {% for location in locations -%}
        {%- set transitions=input_with_location2guard_with_action_with_target[input][location]  -%}
        {%- if  transitions %}
            case {{ location  }}:
                {% for transition in transitions -%}
                    {%- if transition['guard'] -%}
                        if ( {{ transition['guard'] }} ) {
                            guardTaken="{{ transition['guard'] }}"; 
                            {%- for action_statement in transition['action_statements'] %}
                            {{action_statement}};
                            {%- endfor %}
                            currentLoc = Location.{{ transition['target'] }};
                            break;
                        }
                    {%else -%}
                        guardTaken=""; 
                        {%- for action_statement in transition['action_statements'] %}
                        {{action_statement}};
                        {%- endfor %}
                        currentLoc = Location.{{ transition['target'] }};
                        break;
                    {%endif -%}
                {%- endfor -%}

        {%- endif -%}
        {%- endfor %}
        default:
        }
    }
    {% endfor %}


    //Outputs
    public OutputAction delta() {
        int paramIndex = 0;
        String methodName = "Oquiescence";
        List < Parameter > result = new ArrayList < Parameter > ();
        switch (currentLoc) {
        {% for location in locations -%}
        {%- set transitions=location2guard_with_action_with_output_with_target[location]  -%}
        {%- if  transitions %}
            case {{ location  }}:
                {% for transition in transitions -%}
                    {%- if transition['guard'] -%}
                        if ( {{ transition['guard'] }} ) {
                            {%- for action_statement in transition['action_statements'] %}
                            {{action_statement}};
                            {%- endfor %}
                            methodName = "{{ transition['output_event'] }}";
                            {%- for param in transition['output_event_params'] %}
                            result.add(new Parameter({{ param }}, paramIndex));
                            {%- endfor %}
                            currentLoc = Location.{{ transition['target'] }};
                            break;
                        }
                    {%else -%}
                        {%- for action_statement in transition['action_statements'] %}
                        {{action_statement}};
                        {%- endfor %}
                        methodName = "{{ transition['output_event'] }}";
                        {%- for param in transition['output_event_params'] %}
                        result.add(new Parameter({{ param }}, paramIndex));
                        {%- endfor %}
                        currentLoc = Location.{{ transition['target'] }};
                        break;
                    {%endif -%}
                {%- endfor -%}

        {%- endif -%}
        {%- endfor %}
        default:
        }
        return new OutputAction(methodName, result);
    }


    public OutputAction processSymbol(InputAction methodWrapper) {
        {% for input in inputInterfaces -%}
        if (methodWrapper.getMethodName().equals("{{input}}")) {
            List < Parameter > params = methodWrapper.getParameters();
            {{input}}(
            {%- for paramtype in inputInterfaces[input] -%}
               (params.get( {{- loop.index0 -}} ).getValue())
               {%- if not loop.last -%}, {%- endif %}
            {%- endfor -%}
            );
            middle=currentLoc;
            return delta();
        }
        {% endfor %}
        // else : 
        //0.3 logger.fatal("SUT does not support the input:" + methodWrapper.getMethodName());
        throw new RuntimeException("SUT does not support the input:" + methodWrapper.getMethodName());
    }

  	@Override
	public sut.interfaces.OutputAction sendInput( sut.interfaces.InputAction action) {
                start=currentLoc;
		InputAction ia = new InputAction(action);
		OutputAction  oa=processSymbol(ia);
                end=currentLoc;
                //0.3 logger.debug("guard: " + guardTaken ); 
                //0.3 logger.debug("transition: " + start + " --" + ia.toString()  + " -> " + middle +  " --" + oa.toString()  + " -> " + end);
		return oa;  //oa implements sut.interfaces.OutputAction interface
	}

	@Override
	public void sendReset() {
		reset();
	}

}
