#!/usr/bin/env python
"""
     usage: sut_uppaal2register uppaal_modelfile register_modelfile    
"""
# Author: Harco Kuppens


import sys, os,  pprint, re, getpass, tempfile   # standard libraries
import argparse # only in standard lib for python 2.7 and later -> installed local copy  (pure python versions)

import pp_xml # pretty print xml
import model_parser
import util
import pyuppaal
import register

 



def uppaal2register(uppaal_modelfile,register_modelfile):

    model=register.from_uppaal_modelfile(uppaal_modelfile) 
       
    f=open(register_modelfile,'w')
    f.write( model.to_xml() )
    f.close()
       

def args_parsing(args):

    argparser = argparse.ArgumentParser(prog=os.path.basename(args[0]))

    argparser.add_argument('uppaal_modelfile', help='the uppaal model file used as input')
    argparser.add_argument('register_modelfile', help='the to be generated register modelfile ')

    parse_result=argparser.parse_args(args[1:])


    # handle input/output file argument
    uppaal_modelfile=os.path.abspath(parse_result.uppaal_modelfile).replace('\\','/')
    register_modelfile=os.path.abspath(parse_result.register_modelfile).replace('\\','/')

    # check input
    util.check_isreadablefile(uppaal_modelfile)

    return (uppaal_modelfile,register_modelfile)

   
def main(args):
    """
     usage: sut_uppaal2register uppaal_modelfile register_modelfile    

    """  
    (uppaal_modelfile,register_modelfile)=args_parsing(args)
    uppaal2register(uppaal_modelfile,register_modelfile)

def test():
    uppaal_modelfile="uppaal-automata.xml"
    register_modelfile="out.xml"

    #print pp_xml.pp_file(uppaal_modelfile)
    #exit();

    
    regmodel=register.from_uppaal_modelfile(uppaal_modelfile) 
       
    regmodel.to_file("reg1.xml")   
       
    #print regmodel.to_xml() 
   
    # pretty print; works only on valid xml
    #print pp_xml.pformat(regmodel.to_xml(),step="    ") 


    #TODO:
    #print("\n\nconvert back to uppaal\n----------------------------------")

    uppmodel=regmodel.to_uppaal()
    
    regmodel2=register.from_uppaal_model(uppmodel)
    #pp_xml.pprint(regmodel2.to_xml())
    regmodel.to_file("reg2.xml") 
    
    #print pp_xml.pformat(pp_xml.strip( uppmodel.to_xml() ))
    #print pp_xml.pformat( uppmodel.to_xml() )
    #print uppmodel.to_xml()



if __name__ == "__main__":
    main(sys.argv)



